/* (C) Copyright International Business Machines Corporation 23 January  */
/* 1990.  All Rights Reserved.  */
/*   */
/* See the file USERAGREEMENT distributed with this software for full  */
/* terms and conditions of use.  */
/* Makefile */
/* Author: Andy Lowry */
/* SCCS Info: @(#)Makefile	1.6  */

/* This make file builds binaries from the LI sources produced in */
/* ../ligen. */

/* Set the default target here at the top so there's no confusion... */
all:	initial
initial::

/* Get standard definitions and suffix rules */
#include "includefile"

/* Where to load .po files from... */
LOADPATH =	$(PROCDIR)
/* Where to load .do files from */
DEFPATH =	$(GENHROOT)/bin:$(HROOT)/hermes/defs:$(DEFDIR)
/* Normally we're just working with a single system */
GENHROOT =	$(HROOT)

/* Here's the rule for assembling the .li files */
.li.po:	$<
	$(ENV) $(HERMENV) $(ASM) $<

/* Compiled modules */
POFILES =	root.po pcom.po findfile.po pathload.po pathreadobj.po \
		loadprog.po load_program.po store_program.po \
		rmanager.po userrm.po
POFILESZ =	root.po.Z pcom.po.Z findfile.po.Z pathload.po.Z pathreadobj.po.Z \
		loadprog.po.Z load_program.po.Z store_program.po.Z \
		rmanager.po.Z userrm.po.Z

/* Assemble the LI files */
all:	$(POFILES)
install: all
	cp $(POFILES) $(PROCDIR)

liclean::
	rm -f *.li
